( a/d converter driver )

[ifdef] admux

( data buffer )

010 var adc_data


( adc isr )

idpx

adc vector
  pushsreg
  temp0 push,
  temp1 push,
  xl push,
  xh push,

  ( get address for current channel )
  xl adc_data lo ldi,
  xh adc_data hi ldi,
  temp0 admux fetch
  temp0 07 andi,
  temp0 lsl,
  xl temp0 add,
  xh zero adc,

  ( save adc value in ram )
  temp0 adcl fetch
  temp1 adch fetch
  temp0 stx+,
  temp1 stx+,
  
  ( select next channel )
  temp0 admux fetch
  temp1 temp0 mov,
  temp0 0f8 andi,
  temp1 inc,
  temp1 007 andi,
  temp0 temp1 or,
  admux temp0 store

  ( start next conversion )
  adcsra adsc set-bit

  xh pop,
  xl pop,
  temp1 pop,
  temp0 pop,
  popsreg
  reti,

idpx

s" adc@" link, ( n1 -- n2 )
( fetch adc reading )
  2*,
  xl adc_data lo ldi,
  xh adc_data hi ldi,
  xl tosl add,
  xh tosh adc,
  cli,
  tosl ldx+,
  tosh ldx+,
  sei,
  ret,


s" adc" link, ( -- )
( enable adc )

[ifdef] didr0
  ( disable digital input drivers )
  temp0 0ff ldi,
  didr0 temp0 store
[then]

  ( start ADC on channel 0, left justify result )
  temp0 adlar 2^ ldi,
  admux temp0 store

  ( enable ADC, ADC interrupt, set prescaler to 128, and start first conversion )
  temp0 aden 2^ adsc 2^ or adie 2^ or adps2 2^ or adps1 2^ or adps0 2^ or ldi,
  adcsra temp0 store
  ret,


s" /adc" link, ( -- )
( disable adc )

  adcsra zero store

[ifdef] didr0
  didr0 zero store
[then]

  ret,

[then]

