( spi )


s" spi" link, ( -- )
( enable spi )
  ( configure i/o pins )
  ss set-bit
  sck set-bit
  mosi set-bit
  miso clear-bit

  ( enable double speed mode )
  temp0 spi2x 2^ ldi,
  spsr temp0 store

  ( enable master mode at clk/2, sample on falling edge )
  temp0 spe 2^ mstr 2^ or cpol 2^ or ldi,
  spcr temp0 store
  ret,


s" /spi" link, ( -- )
( disable spi )
  spcr zero store
  ret,


s" spix" link, ( c1 -- c2 )
( transfer byte )
label spix_
  ( start transmission )
  spdr tosl store

  ( wait until complete )
  begin,
    temp0 spsr fetch
    temp0 spif 2^ andi,
  z while,
    pause_ call
  repeat,
  
  ( get response )
  tosl spdr fetch
  tosh clr,
  ret,


s" spitx" link, ( c -- )
( send byte )
  spix_ call
  drop,
  ret,


s" spirx" link, ( -- c )
( receive byte )
  0 lit,
  spix_ jump

