( system tick )


( tick counter )

02 var ticks

device s" at90can32" str=
device s" at90can64" str= or
device s" at90can128" str= or [if]

( initialize timer0 )

label timer_init
  ( clear ticks )
  ticks zero store
  ticks 1 + zero store
  
  ( compare of 250 -> 1ms interrupt period )
  temp0 0fa ldi,
  ocr0a temp0 store

  ( output compare interrupt )
  temp0 ocie0a 2^ ldi,
  timsk0 temp0 store

  ( timer0 clear timer on compare, prescaler at /64 )
  temp0 wgm01 2^ cs01 2^ or cs00 2^ or ldi,
  tccr0a temp0 store
  ret,

[then]

device s" atmega8" str=
device s" atmega16" str= or
device s" atmega162" str= or
device s" atmega32" str= or [if]

( initialize timer2 )

label timer_init
  ( clear ticks )
  ticks zero store
  ticks 1 + zero store

  ( compare of 250 -> 1ms interrupt period )
  temp0 0fa ldi,
  ocr2 temp0 store

  ( output compare interrupt )
  temp0 ocie2 2^ ldi,
  timsk temp0 store

  ( timer2 clear timer on compare, prescaler at /64 )
  temp0 wgm21 2^ cs22 2^ or ldi,
  tccr2 temp0 store
  ret,

[then]

device s" atmega128" str= [if]

( initialize timer2 )

label timer_init
  ( clear ticks )
  ticks zero store
  ticks 1 + zero store
  
  ( compare of 250 -> 1ms interrupt period )
  temp0 0fa ldi,
  ocr2 temp0 store

  ( output compare interrupt )
  temp0 ocie2 2^ ldi,
  timsk temp0 store

  ( timer2 clear timer on compare, prescaler at /64 )
  temp0 wgm21 2^ cs21 2^ or cs20 2^ or ldi,
  tccr2 temp0 store
  ret,

[then]


s" ticks" link, ( -- x )
( fetch tick counter )
  dup,
  cli,
  tosl ticks fetch
  tosh ticks 1 + fetch
  sei,
  ret,


( timer isr )

idpx

device s" at90can32" str=
device s" at90can64" str= or
device s" at90can128" str= or [if]
  timer0_compare vector
[then]

device s" atmega8" str=
device s" atmega16" str= or
device s" atmega162" str= or
device s" atmega32" str= or
device s" atmega128" str= or [if]
  timer2_compare vector
[then]

  xl push,
  xl sreg fetch
  xl push,
  xh push,

  xl ticks fetch
  xh ticks 1 + fetch
  xx 1 adiw,
  ticks xl store
  ticks 1 + xh store

  xh pop,
  xl pop,
  sreg xl store
  xl pop,
  reti,

idpx

